#!/usr/bin/python
#
# Test interface to the PCI or CIO QUAD04 board.
#
#  Copyright (C) 2003, John Conner (conner@empiredi.com)
# 
# 
#  This program is free software; you can redistribute
#  it and/or modify it under the terms of the GNU General
#  Public License as published by the Free Software
#  Foundation; either version 2 of the License, or (at your
#  option) any later version.
# 
#  This program is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied
#  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
#  PURPOSE.  See the GNU General Public License for more
#  details.
#  
#  You should have received a copy of the GNU General Public
#  License along with this program; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place,
#  Suite 330, Boston, MA  02111-1307  USA
# 
# Copyright 2003 by Empire Digital Instruments and
#                   ImageMap Inc. , All Rights Reserved.
#
"""
A simple minded test of the quad04 drivers. Reads counter 1 
every 0.1 second and prints the value. If an encoder is
attached the count can be seen to go up and down as the 
shaft is turned back and forth.

The xxx_quad04 dirvers are installed using the following
commands as root:
    # insmod pci_quad04.o
        or
    # insmod cio_quad04.o

It should be possible to have one of each board in the system
and drivers for both installed. This program will find the 
cio_quad04 in that case.

"""
# $Id: test_1.py,v 1.3 2003/12/12 18:09:43 conner Exp $
rcsid = "$Id: test_1.py,v 1.3 2003/12/12 18:09:43 conner Exp $"
#

import sys, time

cio_cntr_name = '/proc/cio_quad04/cntr_1'
pci_cntr_name = '/proc/pci_quad04/cntr_1'

def get_cntr_1():
    try:
        # first try to open the cio_quad04 counter 1
        file_1 = open( cio_cntr_name, 'r' )
    except:
        try:
            # try to open the pci_quad04 counter 1
            file_1 = open( pci_cntr_name, 'r' )
        except:
            print "Unable to open a quad04 counter."
            print "Be sure the driver is installed."
            sys.exit()
            
    line = file_1.readline()
    file_1.close()
    return line

while 1:
    line = get_cntr_1()
    print line,
    time.sleep(0.1)


