#include "pci-dda.h"
#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <gtk/gtk.h>
#include <comedilib.h>

/* IMPORTANT !!! la valeur tensionaa est comprise entre 1.2V et 4.2V
 *				 la valeur tensiongd est comprise entre 1.0V et 4.2V
 */
 
extern comedi_t * it;		
extern comedi_range * cr;
extern gint max_value;

void init_dda()
{

       
it=comedi_open("/dev/comedi0");
  
// valeur maximum  du registre pour chaque canal
    
     max_value = comedi_get_maxdata(it, SUBDEV, CHAN0);
     max_value = comedi_get_maxdata(it, SUBDEV, CHAN1);
     max_value = comedi_get_maxdata(it, SUBDEV, CHAN2);
     max_value = comedi_get_maxdata(it, SUBDEV, CHAN3);
	
ecrire_dda((gdouble)TENSIONAA_INIT,(gdouble)TENSIONGD_INIT);
	
	}
/* Cette fonction permet d ecrire tensiongd sur le canal 0, 
 * 5-tensiongd sur le canal 1,
 * 5-tensionaa sur le canal 2,
 * tensionaa sur le canal 3
 * pour avoir l'immobilité des moteurs il faut que tensionaa = tensiongd =2.54
 */

void ecrire_dda(gdouble tensionaa, gdouble tensiongd)
	{
		
lsampl_t data; 
gint success;
     
/* conversion de la valeur physique tensiongd en valeur numérique a placer
 * dans le registre de donnees de sortie du canal 0
 */		
		
cr = comedi_get_range(it, SUBDEV, CHAN0, RANGE);     
data = comedi_from_phys(tensiongd, cr, max_value);

/* ecriture effective de la valeur convertie sur le registre du canal 0 */
		
success = comedi_data_write(it,SUBDEV,CHAN0,RANGE,AREF,data);
printf("\nChannel 0 : %d",success);
printf("\n AO0=%f    Data=%d        \n  ", tensiongd, data);
     
// opérations identiques pour les canaux 1,2,3    
cr = comedi_get_range(it, SUBDEV, CHAN1, RANGE);
data = comedi_from_phys((5.0 - tensiongd), cr, max_value);
success = comedi_data_write(it,SUBDEV,CHAN1,RANGE,AREF,data);
printf("\nChannel 1 : %d",success);
printf("\n AO1=%f    Data=%d        \n  ", (5.0 - tensiongd), data);
     
cr = comedi_get_range(it, SUBDEV, CHAN2, RANGE);
data = comedi_from_phys((5.0 - tensionaa), cr, max_value);
success = comedi_data_write(it,SUBDEV,CHAN2,RANGE,AREF,data);
printf("\nChannel 2 : %d",success);
printf("\n AO2=%f    Data=%d        \n  ", (5.0 - tensionaa), data);
     
cr = comedi_get_range(it, SUBDEV, CHAN3, RANGE);
data = comedi_from_phys(tensionaa, cr, max_value);
success = comedi_data_write(it,SUBDEV,CHAN3,RANGE,AREF,data);
printf("\nChannel 3 : %d",success);
printf("\n AO3=%f    Data=%d        \n  ", tensionaa, data);

}

void close_dda(){}
